JUCE: CharPointer_UTF16 Class Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | List of all members
CharPointer_UTF16 Class Referencefinal
juce_core » text

Wraps a pointer to a null-terminated UTF-16 character string, and provides various methods to operate on the data. More...

`#include <juce_CharPointer_UTF16.h>`

## Public Types
enum | { byteOrderMarkBE1 = 0xfe , byteOrderMarkBE2 = 0xff , byteOrderMarkLE1 = 0xff , byteOrderMarkLE2 = 0xfe }
| These values are the byte-order-mark (BOM) values for a UTF-16 stream. More...
using | CharType = int16

## Public Member Functions
| CharPointer_UTF16 (const CharType *rawPointer) noexcept
| CharPointer_UTF16 (const CharPointer_UTF16 &other)=default
CharPointer_UTF16 | operator= (CharPointer_UTF16 other) noexcept
CharPointer_UTF16 | operator= (const CharType *text) noexcept
bool | operator== (CharPointer_UTF16 other) const noexcept
| This is a pointer comparison, it doesn't compare the actual text.
bool | operator!= (CharPointer_UTF16 other) const noexcept
bool | operator<= (CharPointer_UTF16 other) const noexcept
bool | operator< (CharPointer_UTF16 other) const noexcept
bool | operator>= (CharPointer_UTF16 other) const noexcept
bool | operator> (CharPointer_UTF16 other) const noexcept
CharType * | getAddress () const noexcept
| Returns the address that this pointer is pointing to.
| operator const CharType * () const noexcept
| Returns the address that this pointer is pointing to.
bool | isEmpty () const noexcept
| Returns true if this pointer is pointing to a null character.
bool | isNotEmpty () const noexcept
| Returns true if this pointer is not pointing to a null character.
juce_wchar | operator* () const noexcept
| Returns the unicode character that this pointer is pointing to.
CharPointer_UTF16 | operator++ () noexcept
| Moves this pointer along to the next character in the string.
CharPointer_UTF16 | operator-- () noexcept
| Moves this pointer back to the previous character in the string.
juce_wchar | getAndAdvance () noexcept
| Returns the character that this pointer is currently pointing to, and then advances the pointer to point to the next character.
CharPointer_UTF16 | operator++ (int) noexcept
| Moves this pointer along to the next character in the string.
void | operator+= (int numToSkip) noexcept
| Moves this pointer forwards by the specified number of characters.
void | operator-= (int numToSkip) noexcept
| Moves this pointer backwards by the specified number of characters.
juce_wchar | operator[] (int characterIndex) const noexcept
| Returns the character at a given character index from the start of the string.
CharPointer_UTF16 | operator+ (int numToSkip) const noexcept
| Returns a pointer which is moved forwards from this one by the specified number of characters.
CharPointer_UTF16 | operator- (int numToSkip) const noexcept
| Returns a pointer which is moved backwards from this one by the specified number of characters.
void | write (juce_wchar charToWrite) noexcept
| Writes a unicode character to this string, and advances this pointer to point to the next position.
void | writeNull () const noexcept
| Writes a null character to this string (leaving the pointer's position unchanged).
size_t | length () const noexcept
| Returns the number of characters in this string.
size_t | lengthUpTo (size_t maxCharsToCount) const noexcept
| Returns the number of characters in this string, or the given value, whichever is lower.
size_t | lengthUpTo (CharPointer_UTF16 end) const noexcept
| Returns the number of characters in this string, or up to the given end pointer, whichever is lower.
size_t | sizeInBytes () const noexcept
| Returns the number of bytes that are used to represent this string.
CharPointer_UTF16 | findTerminatingNull () const noexcept
| Returns a pointer to the null character that terminates this string.
template<typename CharPointer >
void | writeAll (CharPointer src) noexcept
| Copies a source string to this pointer, advancing this pointer as it goes.
void | writeAll (CharPointer_UTF16 src) noexcept
| Copies a source string to this pointer, advancing this pointer as it goes.
template<typename CharPointer >
size_t | writeWithDestByteLimit (CharPointer src, size_t maxDestBytes) noexcept
| Copies a source string to this pointer, advancing this pointer as it goes.
template<typename CharPointer >
void | writeWithCharLimit (CharPointer src, int maxChars) noexcept
| Copies a source string to this pointer, advancing this pointer as it goes.
template<typename CharPointer >
int | compare (CharPointer other) const noexcept
| Compares this string with another one.
template<typename CharPointer >
int | compareUpTo (CharPointer other, int maxChars) const noexcept
| Compares this string with another one, up to a specified number of characters.
template<typename CharPointer >
int | compareIgnoreCase (CharPointer other) const noexcept
| Compares this string with another one.
template<typename CharPointer >
int | compareIgnoreCaseUpTo (CharPointer other, int maxChars) const noexcept
| Compares this string with another one, up to a specified number of characters.
template<typename CharPointer >
int | indexOf (CharPointer stringToFind) const noexcept
| Returns the character index of a substring, or -1 if it isn't found.
int | indexOf (juce_wchar charToFind) const noexcept
| Returns the character index of a unicode character, or -1 if it isn't found.
int | indexOf (juce_wchar charToFind, bool ignoreCase) const noexcept
| Returns the character index of a unicode character, or -1 if it isn't found.
bool | isWhitespace () const noexcept
| Returns true if the first character of this string is whitespace.
bool | isDigit () const noexcept
| Returns true if the first character of this string is a digit.
bool | isLetter () const noexcept
| Returns true if the first character of this string is a letter.
bool | isLetterOrDigit () const noexcept
| Returns true if the first character of this string is a letter or digit.
bool | isUpperCase () const noexcept
| Returns true if the first character of this string is upper-case.
bool | isLowerCase () const noexcept
| Returns true if the first character of this string is lower-case.
juce_wchar | toUpperCase () const noexcept
| Returns an upper-case version of the first character of this string.
juce_wchar | toLowerCase () const noexcept
| Returns a lower-case version of the first character of this string.
int | getIntValue32 () const noexcept
| Parses this string as a 32-bit integer.
int64 | getIntValue64 () const noexcept
| Parses this string as a 64-bit integer.
double | getDoubleValue () const noexcept
| Parses this string as a floating point double.
CharPointer_UTF16 | findEndOfWhitespace () const noexcept
| Returns the first non-whitespace character in the string.
void | incrementToEndOfWhitespace () noexcept
| Move this pointer to the first non-whitespace character in the string.
CharPointer_UTF16 | atomicSwap (CharPointer_UTF16 newValue)
| Atomically swaps this pointer for a new value, returning the previous value.

## Static Public Member Functions
static size_t | getBytesRequiredFor (juce_wchar charToWrite) noexcept
| Returns the number of bytes that would be needed to represent the given unicode character in this encoding format.
template<class CharPointer >
static size_t | getBytesRequiredFor (CharPointer text) noexcept
| Returns the number of bytes that would be needed to represent the given string in this encoding format.
static bool | canRepresent (juce_wchar character) noexcept
| Returns true if the given unicode character can be represented in this encoding.
static bool | isValidString (const CharType *dataToTest, int maxBytesToRead)
| Returns true if this data contains a valid string in this encoding.
static bool | isByteOrderMarkBigEndian (const void *possibleByteOrder) noexcept
| Returns true if the first pair of bytes in this pointer are the UTF16 byte-order mark (big endian).
static bool | isByteOrderMarkLittleEndian (const void *possibleByteOrder) noexcept
| Returns true if the first pair of bytes in this pointer are the UTF16 byte-order mark (little endian).

## Detailed Description

Wraps a pointer to a null-terminated UTF-16 character string, and provides various methods to operate on the data.

See also
  CharPointer_UTF8, CharPointer_UTF32

## Member Typedef Documentation

## ◆ CharType

using CharPointer_UTF16::CharType = int16

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum

These values are the byte-order-mark (BOM) values for a UTF-16 stream.

Enumerator
byteOrderMarkBE1 |
byteOrderMarkBE2 |
byteOrderMarkLE1 |
byteOrderMarkLE2 |

## Constructor & Destructor Documentation

## ◆ CharPointer_UTF16() [1/2]

CharPointer_UTF16::CharPointer_UTF16 | ( | const CharType * | rawPointer | ) |
| explicitnoexcept

Referenced by atomicSwap(), and findTerminatingNull().

## ◆ CharPointer_UTF16() [2/2]

CharPointer_UTF16::CharPointer_UTF16 | ( | const CharPointer_UTF16 & | other | ) |
| default

## Member Function Documentation

## ◆ operator=() [1/2]

CharPointer_UTF16 CharPointer_UTF16::operator= | ( | CharPointer_UTF16 | other | ) |
| noexcept

## ◆ operator=() [2/2]

CharPointer_UTF16 CharPointer_UTF16::operator= | ( | const CharType * | text | ) |
| noexcept

## ◆ operator==()

bool CharPointer_UTF16::operator== | ( | CharPointer_UTF16 | other | ) | const
| noexcept

This is a pointer comparison, it doesn't compare the actual text.

## ◆ operator!=()

bool CharPointer_UTF16::operator!= | ( | CharPointer_UTF16 | other | ) | const
| noexcept

## ◆ operator<=()

bool CharPointer_UTF16::operator<= | ( | CharPointer_UTF16 | other | ) | const
| noexcept

## ◆ operator<()

bool CharPointer_UTF16::operator< | ( | CharPointer_UTF16 | other | ) | const
| noexcept

## ◆ operator>=()

bool CharPointer_UTF16::operator>= | ( | CharPointer_UTF16 | other | ) | const
| noexcept

## ◆ operator>()

bool CharPointer_UTF16::operator> | ( | CharPointer_UTF16 | other | ) | const
| noexcept

## ◆ getAddress()

CharType * CharPointer_UTF16::getAddress | ( |  | ) | const
| noexcept

Returns the address that this pointer is pointing to.

## ◆ operator const CharType *()

CharPointer_UTF16::operator const CharType * | ( |  | ) | const
| noexcept

Returns the address that this pointer is pointing to.

## ◆ isEmpty()

bool CharPointer_UTF16::isEmpty | ( |  | ) | const
| noexcept

Returns true if this pointer is pointing to a null character.

## ◆ isNotEmpty()

bool CharPointer_UTF16::isNotEmpty | ( |  | ) | const
| noexcept

Returns true if this pointer is not pointing to a null character.

## ◆ operator*()

juce_wchar CharPointer_UTF16::operator* | ( |  | ) | const
| noexcept

Returns the unicode character that this pointer is pointing to.

## ◆ operator++() [1/2]

CharPointer_UTF16 CharPointer_UTF16::operator++ | ( |  | ) |
| noexcept

Moves this pointer along to the next character in the string.

## ◆ operator--()

CharPointer_UTF16 CharPointer_UTF16::operator-- | ( |  | ) |
| noexcept

Moves this pointer back to the previous character in the string.

## ◆ getAndAdvance()

juce_wchar CharPointer_UTF16::getAndAdvance | ( |  | ) |
| noexcept

Returns the character that this pointer is currently pointing to, and then advances the pointer to point to the next character.

## ◆ operator++() [2/2]

CharPointer_UTF16 CharPointer_UTF16::operator++ | ( | int |  | ) |
| noexcept

Moves this pointer along to the next character in the string.

## ◆ operator+=()

void CharPointer_UTF16::operator+= | ( | int | numToSkip | ) |
| noexcept

Moves this pointer forwards by the specified number of characters.

Referenced by operator-=().

## ◆ operator-=()

void CharPointer_UTF16::operator-= | ( | int | numToSkip | ) |
| noexcept

Moves this pointer backwards by the specified number of characters.

References operator+=().

## ◆ operator[]()

juce_wchar CharPointer_UTF16::operator[] | ( | int | characterIndex | ) | const
| noexcept

Returns the character at a given character index from the start of the string.

## ◆ operator+()

CharPointer_UTF16 CharPointer_UTF16::operator+ | ( | int | numToSkip | ) | const
| noexcept

Returns a pointer which is moved forwards from this one by the specified number of characters.

## ◆ operator-()

CharPointer_UTF16 CharPointer_UTF16::operator- | ( | int | numToSkip | ) | const
| noexcept

Returns a pointer which is moved backwards from this one by the specified number of characters.

## ◆ write()

void CharPointer_UTF16::write | ( | juce_wchar | charToWrite | ) |
| noexcept

Writes a unicode character to this string, and advances this pointer to point to the next position.

## ◆ writeNull()

void CharPointer_UTF16::writeNull | ( |  | ) | const
| noexcept

Writes a null character to this string (leaving the pointer's position unchanged).

## ◆ length()

size_t CharPointer_UTF16::length | ( |  | ) | const
| noexcept

Returns the number of characters in this string.

## ◆ lengthUpTo() [1/2]

size_t CharPointer_UTF16::lengthUpTo | ( | size_t | maxCharsToCount | ) | const
| noexcept

Returns the number of characters in this string, or the given value, whichever is lower.

References CharacterFunctions::lengthUpTo().

## ◆ lengthUpTo() [2/2]

size_t CharPointer_UTF16::lengthUpTo | ( | CharPointer_UTF16 | end | ) | const
| noexcept

Returns the number of characters in this string, or up to the given end pointer, whichever is lower.

References end(), and CharacterFunctions::lengthUpTo().

## ◆ sizeInBytes()

size_t CharPointer_UTF16::sizeInBytes | ( |  | ) | const
| noexcept

Returns the number of bytes that are used to represent this string.

This includes the terminating null character.

## ◆ getBytesRequiredFor() [1/2]

static size_t CharPointer_UTF16::getBytesRequiredFor | ( | juce_wchar | charToWrite | ) |
| staticnoexcept

Returns the number of bytes that would be needed to represent the given unicode character in this encoding format.

Referenced by getBytesRequiredFor().

## ◆ getBytesRequiredFor() [2/2]

template<class CharPointer >

static size_t CharPointer_UTF16::getBytesRequiredFor | ( | CharPointer | text | ) |
| staticnoexcept

Returns the number of bytes that would be needed to represent the given string in this encoding format.

The value returned does NOT include the terminating null character.

References getBytesRequiredFor().

## ◆ findTerminatingNull()

CharPointer_UTF16 CharPointer_UTF16::findTerminatingNull | ( |  | ) | const
| noexcept

Returns a pointer to the null character that terminates this string.

References CharPointer_UTF16().

## ◆ writeAll() [1/2]

template<typename CharPointer >

void CharPointer_UTF16::writeAll | ( | CharPointer | src | ) |
| noexcept

Copies a source string to this pointer, advancing this pointer as it goes.

References CharacterFunctions::copyAll().

## ◆ writeAll() [2/2]

void CharPointer_UTF16::writeAll | ( | CharPointer_UTF16 | src | ) |
| noexcept

Copies a source string to this pointer, advancing this pointer as it goes.

## ◆ writeWithDestByteLimit()

template<typename CharPointer >

size_t CharPointer_UTF16::writeWithDestByteLimit | ( | CharPointer | src,
|  | size_t | maxDestBytes )
| noexcept

Copies a source string to this pointer, advancing this pointer as it goes.

The maxDestBytes parameter specifies the maximum number of bytes that can be written to the destination buffer before stopping.

References CharacterFunctions::copyWithDestByteLimit().

## ◆ writeWithCharLimit()

template<typename CharPointer >

void CharPointer_UTF16::writeWithCharLimit | ( | CharPointer | src,
|  | int | maxChars )
| noexcept

Copies a source string to this pointer, advancing this pointer as it goes.

The maxChars parameter specifies the maximum number of characters that can be written to the destination buffer before stopping (including the terminating null).

References CharacterFunctions::copyWithCharLimit().

## ◆ compare()

template<typename CharPointer >

int CharPointer_UTF16::compare | ( | CharPointer | other | ) | const
| noexcept

Compares this string with another one.

References CharacterFunctions::compare().

## ◆ compareUpTo()

template<typename CharPointer >

int CharPointer_UTF16::compareUpTo | ( | CharPointer | other,
|  | int | maxChars ) const
| noexcept

Compares this string with another one, up to a specified number of characters.

References CharacterFunctions::compareUpTo().

## ◆ compareIgnoreCase()

template<typename CharPointer >

int CharPointer_UTF16::compareIgnoreCase | ( | CharPointer | other | ) | const
| noexcept

Compares this string with another one.

References CharacterFunctions::compareIgnoreCase().

## ◆ compareIgnoreCaseUpTo()

template<typename CharPointer >

int CharPointer_UTF16::compareIgnoreCaseUpTo | ( | CharPointer | other,
|  | int | maxChars ) const
| noexcept

Compares this string with another one, up to a specified number of characters.

References CharacterFunctions::compareIgnoreCaseUpTo().

## ◆ indexOf() [1/3]

template<typename CharPointer >

int CharPointer_UTF16::indexOf | ( | CharPointer | stringToFind | ) | const
| noexcept

Returns the character index of a substring, or -1 if it isn't found.

References CharacterFunctions::indexOf().

## ◆ indexOf() [2/3]

int CharPointer_UTF16::indexOf | ( | juce_wchar | charToFind | ) | const
| noexcept

Returns the character index of a unicode character, or -1 if it isn't found.

References CharacterFunctions::indexOfChar().

## ◆ indexOf() [3/3]

int CharPointer_UTF16::indexOf | ( | juce_wchar | charToFind,
|  | bool | ignoreCase ) const
| noexcept

Returns the character index of a unicode character, or -1 if it isn't found.

References CharacterFunctions::indexOfChar(), and CharacterFunctions::indexOfCharIgnoreCase().

## ◆ isWhitespace()

bool CharPointer_UTF16::isWhitespace | ( |  | ) | const
| noexcept

Returns true if the first character of this string is whitespace.

References CharacterFunctions::isWhitespace().

## ◆ isDigit()

bool CharPointer_UTF16::isDigit | ( |  | ) | const
| noexcept

Returns true if the first character of this string is a digit.

References CharacterFunctions::isDigit().

## ◆ isLetter()

bool CharPointer_UTF16::isLetter | ( |  | ) | const
| noexcept

Returns true if the first character of this string is a letter.

References CharacterFunctions::isLetter().

## ◆ isLetterOrDigit()

bool CharPointer_UTF16::isLetterOrDigit | ( |  | ) | const
| noexcept

Returns true if the first character of this string is a letter or digit.

References CharacterFunctions::isLetterOrDigit().

## ◆ isUpperCase()

bool CharPointer_UTF16::isUpperCase | ( |  | ) | const
| noexcept

Returns true if the first character of this string is upper-case.

References CharacterFunctions::isUpperCase().

## ◆ isLowerCase()

bool CharPointer_UTF16::isLowerCase | ( |  | ) | const
| noexcept

Returns true if the first character of this string is lower-case.

References CharacterFunctions::isLowerCase().

## ◆ toUpperCase()

juce_wchar CharPointer_UTF16::toUpperCase | ( |  | ) | const
| noexcept

Returns an upper-case version of the first character of this string.

References CharacterFunctions::toUpperCase().

## ◆ toLowerCase()

juce_wchar CharPointer_UTF16::toLowerCase | ( |  | ) | const
| noexcept

Returns a lower-case version of the first character of this string.

References CharacterFunctions::toLowerCase().

## ◆ getIntValue32()

int CharPointer_UTF16::getIntValue32 | ( |  | ) | const
| noexcept

Parses this string as a 32-bit integer.

## ◆ getIntValue64()

int64 CharPointer_UTF16::getIntValue64 | ( |  | ) | const
| noexcept

Parses this string as a 64-bit integer.

## ◆ getDoubleValue()

double CharPointer_UTF16::getDoubleValue | ( |  | ) | const
| noexcept

Parses this string as a floating point double.

References CharacterFunctions::getDoubleValue().

## ◆ findEndOfWhitespace()

CharPointer_UTF16 CharPointer_UTF16::findEndOfWhitespace | ( |  | ) | const
| noexcept

Returns the first non-whitespace character in the string.

References CharacterFunctions::findEndOfWhitespace().

## ◆ incrementToEndOfWhitespace()

void CharPointer_UTF16::incrementToEndOfWhitespace | ( |  | ) |
| noexcept

Move this pointer to the first non-whitespace character in the string.

References CharacterFunctions::incrementToEndOfWhitespace().

## ◆ canRepresent()

static bool CharPointer_UTF16::canRepresent | ( | juce_wchar | character | ) |
| staticnoexcept

Returns true if the given unicode character can be represented in this encoding.

## ◆ isValidString()

static bool CharPointer_UTF16::isValidString | ( | const CharType * | dataToTest,
|  | int | maxBytesToRead )
| static

Returns true if this data contains a valid string in this encoding.

## ◆ atomicSwap()

CharPointer_UTF16 CharPointer_UTF16::atomicSwap | ( | CharPointer_UTF16 | newValue | ) |

Atomically swaps this pointer for a new value, returning the previous value.

References CharPointer_UTF16().

## ◆ isByteOrderMarkBigEndian()

static bool CharPointer_UTF16::isByteOrderMarkBigEndian | ( | const void * | possibleByteOrder | ) |
| staticnoexcept

Returns true if the first pair of bytes in this pointer are the UTF16 byte-order mark (big endian).

The pointer must not be null, and must contain at least two valid bytes.

References byteOrderMarkBE1, byteOrderMarkBE2, jassert, JUCE_BEGIN_IGNORE_WARNINGS_MSVC, and JUCE_END_IGNORE_WARNINGS_MSVC.

## ◆ isByteOrderMarkLittleEndian()

static bool CharPointer_UTF16::isByteOrderMarkLittleEndian | ( | const void * | possibleByteOrder | ) |
| staticnoexcept

Returns true if the first pair of bytes in this pointer are the UTF16 byte-order mark (little endian).

The pointer must not be null, and must contain at least two valid bytes.

References byteOrderMarkLE1, byteOrderMarkLE2, jassert, JUCE_BEGIN_IGNORE_WARNINGS_MSVC, and JUCE_END_IGNORE_WARNINGS_MSVC.

The documentation for this class was generated from the following file:

- juce_CharPointer_UTF16.h